TACHYON
{
		UPDATED 20121124.1330 - BBR renamed a bunch of words ,added multiple
		                        screen menus and did some changes per suggestions
		                        by PJ
		UPDATED 20121123.1330 - BBR added LCD display
		UPDATED 20121123.1000 - BBR incorportaed PJ's suggestions
		CREATED 20121122.1800 - BB Riley, Underhill Center, VT  
		                        brianbr@wulfden.org
		BASEDON	code by Savage Circuits (spin) and Parallax (bs2)

		TESTED  Tachyon Forth V21 121114.1330 Extend 121113.1200
		
		Grayhill Incremental Rotary Encoder - Parallax p/n: 27805
		
		http://www.parallax.com/Portals/0/Downloads/docs/prod/acc/Series25LEncoder.pdf
}		
		
: QuadDecoder.fth	." Quadrature decoder driver - 20121124.1330"  ;

#P23	CONSTANT	#lcdpin		\  LCD port
#P26	CONSTANT	#enc.a		\  A output from encoder
#P27	CONSTANT	#enc.b		\  B output from encoder

#120	CONSTANT	#maxdur		\  max value for duration
#10		CONSTANT	#maxon		\  max value for on period
#10		CONSTANT	#maxoff		\  max value for off period

LONG	oldBits,newBits

LONG	varptr					\  variable to serve as pointer to pass data
								\  addreses to QDEC@ (indirect addressing)
LONG	maxdata,duration,onperiod,offperiod


: QE@	( -- ) IN@ #enc.a SHR 3 AND ;	\ get current state	

: QDEC@	( dataddr datamax -- )	\ QuadratureDecoder
	maxdata !					\  write max allowed value
	varptr !					\  write var address to pointer
	#enc.a PININP				\  Set encoder pins to inputs
	#enc.b PININP
	QE@  oldBits !				\  Pre-initialize oldBits (prevents 
								\       non-zero starting count)
	BEGIN
    	QE@	DUP newBits !		\  read encoder
		oldBits @
		<> IF					\  compare oldBits to newBits. Has it changed? 
		 		\ counter = counter - 1 + (2 * (newBits.BIT0 ^ oldBits.BIT1))
	     		\ the next 4 lines are the TF implementation of the above PBASIC
			newBits @ 1 AND		\  determine direction and add or subtract from counter
			oldBits @ 2/
			XOR 2* 1-
			varptr @ @ +		\  add to old var 
			0 MAX				\  apply min/max - 0 minimum
			maxdata @ MIN		\  cap the top
			varptr @ !			\  write new val to var
			newBits @ oldBits !  \ Update oldBits
			." ?x09?y0" varptr @ @ $030A .NUM
		THEN

	KEY? AND UNTIL				  \  this could be replaced by a pushbutton and reading
								  \   a pin
	;

{ The "?" in the various string prints, is the escape character for 
  Peter Anderson Serial LCD firmware }
	
: LCDEMIT	#lcdpin SEROUT ;
: LCD		' LCDEMIT uemit W! ;

: BACKLIGHT	( on/off -- ) IF " ?BA0" ELSE " ?B00" THEN .STR ;	\  This must be used with console redirected
																\  to the LCD. "LCD ON BACKLIGHT CON" or insert
																\  "ON BACKLIGHT" into a section of code already
																\  bracketed by  "LCD ... CON"

: QE1	( -- )					\ QUDRATURE Encoder Demo

	#19200 SERBAUD
	LCD							\  redirect console

\ -------------------------------------------------------
	$30		duration !			\  initialize variable
	." ?f         " 
	duration @ $030A .NUM
	." ?n      duration "
	duration #maxdur QDEC@
	
\ -------------------------------------------------------
	$0A		onperiod !			\  initialize variable
	." ?f         " 
	onperiod @ $030A .NUM
	." ?n      onperiod "
	onperiod #maxon QDEC@

\ -------------------------------------------------------
	$05		offperiod !			\  initialize variable
	." ?f         " 
	offperiod @ $030A .NUM
	." ?n      offperiod "
	offperiod #maxoff QDEC@

\ -------------------------------------------------------

	CON							\  return console
	;
	

END

